////////////////////////////////////////////////////////////////////////////////////
//
// Project: RTPrinter
// Author : Jan Blumenthal
// Start  : 2001/11/26
// $Header: /sources/yasa/executives/rtlinux/examples/rtprinter/rtprinter.c,v 1.1 2003/01/23 09:27:50 bj Exp $
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (See the included file COPYING);
// if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#include <rtl.h>
#include <time.h>
#include <pthread.h>
#include <asm/io.h>
//#include <rtl_sched.h>


/*
#include <rtl.h>
#include <pthread.h>
#include <time.h>
#include <rtl_time.h>
#include <rtl_sync.h>
#include <rtl_sched.h>
#include <rtl_time.h>
#include <pthread.h>
#include <asm/io.h>
//#include <linux/kd.h>
*/
/*
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/version.h>
#include <linux/cons.h>
#include <linux/kd.h>
#include <asm/io.h>
#include <rtl.h>
#include <rtl_sync.h>
#include <posix/pthread.h>
*/


////////////////////////////////////////////////////////////////////////////////////
// uncomment if needed
//#define REALY_WRITE_TO_PORT

////////////////////////////////////////////////////////////////////////////////////
// some definitions
#define 	PI			3.14
#define 	LPT_PORT	0x378
#define 	LPT_IRQ		7

int 		tperiod	= 5000000;		// 500 000 000nsec=0.5ms
int 		toffset	= 500000;		// 200 000 000nsec=0.2ms
int 		tcount1	= 0;
int 		tcount2	= 0;
pthread_t	thread1,
			thread2;


////////////////////////////////////////////////////////////////////////////////////
void *rttask(void *parameter)
{
	hrtime_t	next;
	char		t;

	t=(char)parameter;
	next=clock_gethrtime(rtl_getschedclock())+2*tperiod;
	if (t != 0 )
	{
		next=next+toffset;
	}
	pthread_make_periodic_np(pthread_self(), next, tperiod);

	do
	{
		pthread_wait_np();
#ifdef REALY_WRITE_TO_PORT
		outb(t, LPT_PORT);							// write to LPT_PORT
#else
		if (t != 0 )
		{
			printk("rtprinter: tcount2: %d\n",tcount2);
			tcount2++;
		}
		else
		{
			printk("rtprinter: tcount1: %d\n",tcount1);
			tcount1++;
		}
#endif
	} while (1);
}


////////////////////////////////////////////////////////////////////////////////////
int init_module(void)
{
	int					tstatus;
	pthread_attr_t		attr;
	struct	sched_param sched_param;

	pthread_attr_init(&attr);
	pthread_attr_setcpu_np(&attr, 0);					// select CPU 0
	sched_param.sched_priority=1;
	pthread_attr_setschedparam(&attr, &sched_param);

	printk("rtprinter: Hello world!, tcount1: %d, tcount2: %d\n", tcount1, tcount2);

	tstatus = pthread_create(&thread1, &attr, rttask, (void*) 0);
	tstatus = pthread_create(&thread2, &attr, rttask, (void*) 1);

	return 0;
}


////////////////////////////////////////////////////////////////////////////////////
void cleanup_module(void)
{
	pthread_delete_np(thread1);
	pthread_delete_np(thread2);
	printk("rtprinter: Bye! tcount1: %d, tcount2: %d\n", tcount1, tcount2);
}

