//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// YASA global declarations
//
// Project: Yasa 2
// Author : Jan Blumenthal
// Start  : 2001/11/26
// $Header: /sources/yasa/include/yasa/yasa_errors.h,v 1.3 2003/01/23 09:18:31 bj Exp $
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (See the included file COPYING);
// if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef YASA_ERRORS_INCLUDE
#define	YASA_ERRORS_INCLUDE

#include <errno.h>

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Error messages
#define YASAE_NO_ERROR						0
#define YASAE_UNKNOWN_SCHEDULER				500
#define YASAE_SCHEDULER_ALREADY_EXISTS		501
#define YASAE_WRONG_CPU						502
#define YASAE_EMERGENCYCALL_DEFINE_TWICE	503
#define YASAE_INITIALISING_SCHEDULER		504
#define YASAE_COULD_NOT_OPEN_FIFO			505
#define YASAE_CREATE_THREAD					506			// thread could not be created
#define YASAE_ERROR_IN_YASA_ATTRIBUTS		507
#define YASAE_ERROR_IN_ARGUMENTS			EINVAL
#define YASAE_OUT_OF_MEMORY					ENOMEM
#define YASAE_LOGBUFFER_TOO_SHORT			EINVAL
#define YASAE_COULD_NOT_OPEN_FILE			ENOENT		// thread could not be created
#define YASAE_ENTRY_ALREADY_EXISTS			508
#define YASAE_INTERNAL_ERROR				509
#define YASAE_UNEXPECTED_EOF				510
#define YASAE_PARSING_ERROR					511
#define YASAE_NO_MORE_ENTRIES				512
#define YASAE_OPERATION_ABORTED				513
#define YASAE_NOT_IMPLEMENTED				514
#define YASAE_CREATE_DIRECTORY				515
#define YASAE_WRITE_FILE					516			// file could not be written

typedef int YASA_ERROR;


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif														// ifndef YASA_ERRORS_INCLUDE
