//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// YASA-GUI cusomize declarations.
//
// Project: Yasa 2
// Author : Jan Blumenthal
// Start  : 2001/11/26
// $Header: /sources/yasa/include/yasagui/yasagui_customize.h,v 1.5 2003/01/24 15:47:09 bj Exp $
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (See the included file COPYING);
// if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef YASA_GUI_CUSTOMIZE_INCLUDE
#define	YASA_GUI_CUSTOMIZE_INCLUDE

#include <yasa/yasa_types.h>

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#define YASAGUI_VERSION				2
#define ABOUT_PATH					"doc/about_"
#define DEFAULT_LANGUAGE			"de"
#define LANGUAGE_USED				"de"			// set to "" if you want to use operating system language
#define LANGUAGE_YASA_PREFIX		"yasagui_"		// prefix of filename used as catalog file
#define LANGUAGE_QT_PREFIX			"qt_"
#define EXECUTIVES_DIR				"executives"
#define SCHEDULERS_DIR				"schedulers"
#define HTML_POSTFIX				".html"
#define YASA_POSTFIX				".yasa"
#define YASA_WORKSPACE_FILTER		"*.yasa"
#define SOURCE_FILE_FILTER			"*.c *.cc *.cpp"
#define HEADER_FILE_FILTER			"*.h"
#define PARENTDIR_PREFIX			".."
#define CURRENTDIR_PREFIX			"."
#define NUMBER_SEPARATOR			"."				// used to represent float values
#define EXTENSION_SEPARATOR			'.'				// used to set a file extension "hello.c"
#define LOWEST_STRING				" "				// this should be the lowest (used for sorting) possible string
#define DIR_SEPARATOR				"/"
#define MAINWINDOW_OPEN_MAXIMIZED	true			// true=main window will be opened in maximized mode

#define MDI_OPEN_MAXIMIZED			1				// true=window is maximized by default
#define MDI_WIDTH					640				// 640 pixel
#define MDI_HEIGHT					480				// 480 pixel
#define MDI_SCROLLVIEW_BORDER		8				// border width of mdi windows between slider and contents
#define TABSIZE						4

#define PROJECT_WIDTH				300				// thousanth part of the whole size (German: Promille)
#define OUTPUT_HEIGHT				200				// thousanth part of the whole size (German: Promille)
#define PROJECT_DEFAULT_MAXCPU		1				// Default: one cpu is used
#define PROJECT_TIMER_TICK			100000			// tick value
#define SUPPORT_CALC_PREEMPTIONTIME	0				// do not calculate preemption time by default
#define SUPPORT_TIMERTICK			0				// usually components does not support timer tick
#define YASATIME_JUSTIFYNUMBER		16				// is used in QListViewItems to justify the string to the right
#define YASATIME_JUSTIFYFILL		'0'				// -++- with this fill character
#define EXECUTIVE_DEFAULT_MAXCPU	1				// Default: one cpu is used
#define FIGURE_ICON_APPLICATION			"yasagui/figures/icon_application.xpm"
#define FIGURE_ICON_MDIWINDOW			"yasagui/figures/icon_mdiwindow.xpm"
#define FIGURE_WORKSPACE_NEW			"yasagui/figures/workspace_new.xpm"
#define FIGURE_WORKSPACE_OPEN			"yasagui/figures/workspace_open.xpm"
#define FIGURE_WORKSPACE_SAVE			"yasagui/figures/workspace_save.xpm"
#define FIGURE_EXECUTE					"yasagui/figures/execute.xpm"
#define FIGURE_ZOOM_IN					"yasagui/figures/zoom_in.xpm"
#define FIGURE_ZOOM_OUT					"yasagui/figures/zoom_out.xpm"
#define FIGURE_POINTER_HAND				"yasagui/figures/pointer_hand.xpm"
#define FIGURE_POINTER_HAND_PUSHED		"yasagui/figures/pointer_hand_pushed.xpm"

#define FIGURE_BACKGROUND_OUTPUT		"yasagui/figures/background_output.xpm"
#define FIGURE_BACKGROUND_HELP			"yasagui/figures/background_help.xpm"
#define FIGURE_BACKGROUND_SOURCES		"yasagui/figures/background_sources.xpm"
#define FIGURE_BACKGROUND_LOGFILE		"yasagui/figures/background_logfile.xpm"
#define FIGURE_BACKGROUND_WORKSPACE_TREE "" //yasagui/figures/background_workspace.xpm"
#define FIGURE_BACKGROUND_TIMINGWINDOWS	"yasagui/figures/background_timingwindows.xpm"
#define FIGURE_BACKGROUND_WINDOWS		"yasagui/figures/background_windows.xpm"

#define FIGURE_THREAD_CREATED			"yasagui/figures/logfile/thread_created.xpm"
#define FIGURE_THREAD_ACTIVATE			"yasagui/figures/logfile/thread_activate.xpm"
#define FIGURE_THREAD_EXIT				"yasagui/figures/logfile/thread_exit.xpm"
#define FIGURE_THREAD_START				"yasagui/figures/logfile/thread_start.xpm"
#define FIGURE_THREAD_CONT				"yasagui/figures/logfile/thread_cont.xpm"
#define FIGURE_THREAD_SUSPEND			"yasagui/figures/logfile/thread_suspend.xpm"
#define FIGURE_THREAD_TOLERANCE_START	"yasagui/figures/logfile/thread_tolerance_start.xpm"
#define FIGURE_THREAD_TOLERANCE_CONT	"yasagui/figures/logfile/thread_tolerance_cont.xpm"
#define FIGURE_THREAD_TOLERANCE_SUSPEND "yasagui/figures/logfile/thread_tolerance_suspend.xpm"
#define FIGURE_THREAD_SKIPPED			"yasagui/figures/logfile/thread_skipped.xpm"
#define FIGURE_THREAD_TYPE				"yasagui/figures/logfile/thread_type.xpm"
#define FIGURE_THREAD_EXCLUDED			"yasagui/figures/logfile/thread_excluded.xpm"
#define FIGURE_DEADLINE_MATCH			"yasagui/figures/logfile/deadline_match.xpm"
#define FIGURE_DEADLINE_MISS			"yasagui/figures/logfile/deadline_miss.xpm"
#define FIGURE_DEADLINE_MISS_DETECTED	"yasagui/figures/logfile/deadline_miss_detected.xpm"
#define FIGURE_DEADLINE_TOLERANCE_MISS	"yasagui/figures/logfile/deadline_tolerance_miss.xpm"
#define FIGURE_TIME_TO_COMPUTE			"yasagui/figures/logfile/time_to_compute.xpm"
#define FIGURE_MUTEX_CREATED			"yasagui/figures/logfile/mutex_created.xpm"
#define FIGURE_MUTEX_DESTROYED			"yasagui/figures/logfile/mutex_destroyed.xpm"
#define FIGURE_MUTEX_LOCKED				"yasagui/figures/logfile/mutex_locked.xpm"
#define FIGURE_MUTEX_TRY_N_BLOCKED		"yasagui/figures/logfile/mutex_try_n_blocked.xpm"
#define FIGURE_MUTEX_UNLOCKED			"yasagui/figures/logfile/mutex_unlocked.xpm"
#define FIGURE_MUTEX_RELOCKED			"yasagui/figures/logfile/mutex_relocked.xpm"
#define FIGURE_MUTEX_NOT_LOCKED			"yasagui/figures/logfile/mutex_not_locked.xpm"
#define FIGURE_PRIORITY_CHANGED			"yasagui/figures/logfile/priority_changed.xpm"
#define FIGURE_SYSTEM_CEILING_CHANGED	"yasagui/figures/logfile/system_ceiling_changed.xpm"
#define FIGURE_MESSAGE					"yasagui/figures/logfile/message.xpm"
#define FIGURE_EMERGENCY_THREAD			"yasagui/figures/logfile/emergency_thread.xpm"
#define FIGURE_SCHEDULER_CHANGED		"yasagui/figures/logfile/scheduler_changed.xpm"
#define FIGURE_SCHEDULER_CALLED			"yasagui/figures/logfile/scheduler_called.xpm"
#define FIGURE_SCHEDULER_FINISHED		"yasagui/figures/logfile/scheduler_finished.xpm"
#define FIGURE_SCHEDULER_SWITCH			"yasagui/figures/logfile/scheduler_switch.xpm"
#define FIGURE_SCHEDULER_SYNCHRONIZED_START	"yasagui/figures/logfile/scheduler_synchronized_start.xpm"
#define FIGURE_IDLE_THREAD				"yasagui/figures/logfile/thread_idle.xpm"
#define FIGURE_JITTER					"yasagui/figures/logfile/jitter.xpm"
#if YASAL_MAX!=35
#error There are inconsistences within the logging types!
#endif


#define CONFIG_SPACE					' '				// space
#define CONFIG_TAB						'\t'			// tab
#define CONFIG_NEWLINE					'\n'			// new line
#define CONFIG_RETURN					'\r'			// new line
#define CONFIG_COMMENT					'#'				// comment with '#'
#define CONFIG_COMMENT_2				'/'				// comment with '/'
#define CONFIG_MARKS					'"'				// string are enclosed with
#define CONFIG_NUMBER_BASE				10				// numbers are decimal
#define CONFIG_KEY_OPEN					'<'
#define CONFIG_KEY_CLOSE				'>'
#define CONFIG_KEY_END					'/'

#define CYGWINPATH_EXTENSION			"/cygdrive/"
#define BASH_STARTUP					"bash -c \"%1\""
#define BASH_SCRIPT_STARTUP				"bash -c \". %1\""
#define SG_NEW_LINE						"\n"


#define Q_CONSTUNUSED(x)				(const void )x
#endif																		// ifndef YASA_GUI_CUSTOMIZE_INCLUDE
