//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// YASA application startup code declarations
//
// Project: Yasa 2
// Author : Jan Blumenthal
// Start  : 2002/02/28
// $Header: /sources/yasa/yasagui/application.h,v 1.5 2003/01/24 15:47:40 bj Exp $
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (See the included file COPYING);
// if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef YASAGUI_APPLICATION_INCLUDE
#define	YASAGUI_APPLICATION_INCLUDE


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#include <qapplication.h>
#include <qdir.h>
#include <qtimer.h>

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
class YWorkSpaceManager;
class YPlugInManager;
class YActionHandler;
class YOutput;
class YMainWindow;
class YTranslator;
class YSettings;

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
class YApplication : public QApplication
{	Q_OBJECT
	YWorkSpaceManager		*workspacemanager;							// workspace/project manager
	YPlugInManager			*pluginmanager;								// plugin manager
	YActionHandler			*actionhandler;								// action handler
	YOutput					*output;									// output control
	YMainWindow				*mainwindow;								// main window control
	YTranslator				*translator;								// translator
	YSettings				*settings;
	QString					StartPath;
public:						YApplication(int argc, char** argv) :
							QApplication(argc, argv),
							workspacemanager(0),
							pluginmanager(0),
							actionhandler(0),
							output(0),
							mainwindow(0),
							translator(0),
							settings(0),
							StartPath( QDir::currentDirPath() )
							{
							}
							~YApplication();

	int						InitInstance();
	static YWorkSpaceManager* GetWorkSpaceManager();
	static YPlugInManager*	GetPlugInManager();
	static YActionHandler*	GetActionHandler();
	static YOutput*			GetOutput();
	static YMainWindow*		GetMainWindow();
	static YTranslator*		GetTranslator();
	static YSettings*		GetSettings();
	const QString &			GetStartPath() const					{	return StartPath;		}
	const QString &			GetYasaPath() const						{	return StartPath;		}
//public slots:
//	void					ExecuteCurrentEnvironment();
public slots:
	//! This slot is used to update the window during a compiler run
	void					ProcessEvents()
	{
		processEvents();
		QTimer::singleShot( 100, this, SLOT( ProcessEvents() ) );
	}
};


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif																	// ifndef YASAGUI_APPLICATION_INCLUDE
