//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// YASA application help window browser declarations
//
// Project: Yasa 2
// Author : Jan Blumenthal
// Start  : 2002/02/28
// $Header: /sources/yasa/yasagui/helpwindow.h,v 1.4 2003/01/24 15:47:41 bj Exp $
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (See the included file COPYING);
// if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//! This file contains all functions used to browse the online documentation
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef YASAGUI_HELPWINDOW_INCLUDE
#define	YASAGUI_HELPWINDOW_INCLUDE

#include <qtextbrowser.h>
#include "mainwindow.h"



//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
class YFrameHelpArgs : public YFrameArgs
{	const QString		filename;
public:					YFrameHelpArgs(const QString &title, const QString &fname);
	const QString&		GetFileName() const							{ return filename; }
};


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
class YHelpFrame : public YFrame
{	Q_OBJECT
	QTextBrowser		browser;
						YHelpFrame(QWidget *parent, YFrameArgs &args) :
						YFrame(args),
						browser(parent)
						{}
public:
	virtual int			InitInstance();
	virtual QWidget*	GetMainWidget()								{ return &browser;	}
	static int			OpenHelpWindow();
	static YFrame*		CreateHelpFrame(QWidget *parent, YFrameArgs &args)
						{
							return new YHelpFrame(parent, args );
						}
};





//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif																	// ifndef YASAGUI_HELPWINDOW_INCLUDE
