//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// YASA object definitions
//
// Project: Yasa 2
// Author : Jan Blumenthal
// Start  : 2002/02/28
// $Header: /sources/yasa/yasagui/object.cpp,v 1.3 2003/01/23 09:18:36 bj Exp $
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (See the included file COPYING);
// if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#include "config.h"
#include "object.h"
#include "actions.h"
#include "parser.h"


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int YObject::SetConfig(YInputParser &parser)
{
	if ( parser.CheckSectionStart(YPC_NAME) )
		return parser.ReadContentString(*this);
	if ( parser.CheckSectionStart(YPC_DESCRIPTION) )
		return parser.ReadContentString(description);
	return parser.SectionEnd();
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int YObject::GetConfig(YOutputParser &parser)
{
	int	retvalue;
	retvalue=parser.WriteContentString(YPC_NAME, *this);
		if ( retvalue )	return retvalue;
	retvalue=parser.WriteContentString(YPC_DESCRIPTION, description);
		if ( retvalue )	return retvalue;

	return parser.SectionEnd();
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int YObject::SetDescription(const QString &d)
{
	if ( description!=d)
	{
		description=d;
		ObjectUpdated();
	}
	return 0;
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int YObject::SetName(const QString &n)
{
	if ( n.compare(*this) )
	{
		QString:: operator =(n);
		ObjectUpdated();
	}
	return 0;
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int YObject::SetName(const char *n)
{
	if ( (*this).compare(n) )
	{
		setLatin1(n);
		ObjectUpdated();
	}
	return 0;
}




