//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// YASA results
//
// Project: Yasa 2
// Author : Jan Blumenthal
// Start  : 2002/02/28
// $Header: /sources/yasa/yasagui/results.h,v 1.4 2003/01/24 15:47:42 bj Exp $
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (See the included file COPYING);
// if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef YASAGUI_RESULTS_INCLUDE
#define	YASAGUI_RESULTS_INCLUDE


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#include <yasagui/yasagui.h>
#include "translations.h"
#include "config.h"
#include "object.h"


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
class YResults;


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
class YResultArgs
{public:
	enum RESULT_TYPE		{	PROJECT_RESULTS=0,
								ENVIRONMENT_RESULTS,
								MAX_RESULTS
							};
							YResultArgs(RESULT_TYPE rt) :
							resulttype(rt)
							{}
	RESULT_TYPE				GetResultType() const										{	return resulttype;	}
private:RESULT_TYPE			resulttype;
};


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
class YResult : public YObject
{	YResults				*parent;
public:						YResult( const YObjectArgs &objectargs) :
							YObject(objectargs), parent(0)
							{}
	virtual int				SetConfig(YInputParser &parser);
	virtual int				GetConfig(YOutputParser &parser);
	YResults*				GetParent() const						{	return parent;			}
	void					SetParent(YResults *p) 					{	parent=p;				}
};

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
class YTimingResults : public YResult
{ public:					YTimingResults();
};

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
class YStatisticResults : public YResult
{ public:					YStatisticResults();
};


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//! The parent must be set correctly !!!!
class YResults : public YObject
{	YResultArgs				resultargs;
	YTimingResults			timings;
	YStatisticResults		statistics;
	//! Ptr to parent of results. This can be an YEnvironment or a YProject. This depends on type
	YObject					*parent;
public:						YResults(const YResultArgs &args);
	const YResultArgs &		GetResultArgs() const					{	return resultargs;		}
	YTimingResults &		GetTimingResults()						{	return timings;			}
	YStatisticResults &		GetStatisticResults()					{	return statistics;		}
	virtual int				SetConfig(YInputParser &parser);
	virtual int				GetConfig(YOutputParser &parser);
	YObject*				GetParent() const						{	return parent;			}
	void					SetParent(YObject* p) 					{	parent=p;				}
};










//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif																	// ifndef YASAGUI_RESULTS_INCLUDE
