//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// YASA sources support (managing source and header files)
//
// Project: Yasa 2
// Author : Jan Blumenthal
// Start  : 2002/02/28
// $Header: /sources/yasa/yasagui/sources.h,v 1.4 2003/01/24 15:47:42 bj Exp $
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (See the included file COPYING);
// if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef YASAGUI_SOURCES_INCLUDE
#define	YASAGUI_SOURCES_INCLUDE

#include <yasagui/yasagui.h>
#include <qobject.h>
#include <qlist.h>
#include "list.h"
#include "actionhandler.h"


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
class YInputParser;
class YOutputParser;


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//! source objects are used in lists of sources and headers
class YFilePath : public YObject
{
	Q_OBJECT
	QString					path;								//! path relative to project directory (not workspace!)
public:
							YFilePath(const YObjectArgs &i);
	const QString&			GetPath()								{ return path;					}
	void					SetPath(const QString &p)				{ path=p;						}
	QString					GetAbsPath();
	virtual int				SetConfig(YInputParser &parser);
	virtual int				GetConfig(YOutputParser &parser);
};


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//! source objects are used in lists of sources and headers
class YFilePathSet : public YSet
{
	bool					checkdouble;
public:						YFilePathSet(const CONFIG_STRING sectionkey, const QString &name, YActions *a, YObject *p=0 ) :
							YSet(sectionkey, MSGP_DEFAULT_PROJECTNAME, YObjectArgs(name,a), p),
							checkdouble(true)
							{ }
protected:
	virtual YObject*		AllocNewItem(const YObjectArgs &i);
	virtual YActions*		GetItemActions() const
							{ return YActionHandler::GetActions(YActionHandler::FILEPATH_ACTIONS);	}
};


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
class YSourceSet : public YFilePathSet
{
public:						YSourceSet();
};
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
class YHeaderSet : public YFilePathSet
{
public:						YHeaderSet();
};




//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif																	// ifndef YASAGUI_SOURCES_INCLUDE
