//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// YASA sources view
//
// Project: Yasa 2
// Author : Jan Blumenthal
// Start  : 2002/02/28
// $Header: /sources/yasa/yasagui/sourcesview.cpp,v 1.3 2003/01/23 09:18:38 bj Exp $
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (See the included file COPYING);
// if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#include "sourcesview.h"
#include "filedialog.h"
#include "application.h"
#include "actions.h"
#include "output.h"
#include "settings.h"
#include "environment.h"

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int YFileViewFrame::InitInstance()
{
	YFilePath			*fileobject=GetFilePath();
	QFileInfo	fileinfo(fileobject->GetAbsPath());

	if ( fileinfo.exists() )
	{
#if QT_VERSION>=300
		textbrowser.setWordWrap( QTextEdit::NoWrap );
		textbrowser.setTabStopWidth(TABSIZE);
#endif
		if ( fileobject->GetActions() )
			textbrowser.setFont( ((YFilePathActions*)fileobject->GetActions())->GetFont() );
		textbrowser.mimeSourceFactory()->setExtensionType( fileinfo.extension(false), "text/plain");
		textbrowser.setFrameStyle( QFrame::Panel | QFrame::Sunken );
		textbrowser.setSource( fileinfo.filePath() );
		SetBackdrop();
		return YObjectFrame::InitInstance();
	}
	else
	{
		YApplication::GetOutput()->Warning(MSGP_FILE_NOT_FOUND.arg( fileobject->GetAbsPath() ) );
		return YASAE_COULD_NOT_OPEN_FILE;
	}
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/*
void YFileViewFrame::Reload()
{
	YFilePath			*fileobject=GetFilePath();
	QFileInfo	fileinfo(fileobject->GetAbsPath());

	textbrowser.setText("Huhu");
	if ( fileinfo.exists() )
	{
#if QT_VERSION>=300
		textbrowser.setWordWrap( QTextEdit::NoWrap );
		textbrowser.setTabStopWidth(TABSIZE);
#endif
		if ( fileobject->GetActions() )
			textbrowser.setFont( ((YFilePathActions*)fileobject->GetActions())->GetFont() );
		textbrowser.mimeSourceFactory()->setExtensionType( fileinfo.extension(false), "text/plain");
		textbrowser.setFrameStyle( QFrame::Panel | QFrame::Sunken );
		textbrowser.setSource( fileinfo.filePath() );
		//return;
	}
	else
	{
		YApplication::GetOutput()->Warning(MSGP_FILE_NOT_FOUND.arg( fileobject->GetAbsPath() ) );
		//return YASAE_COULD_NOT_OPEN_FILE;
	}
}
*/

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void YSourceViewFrame::SetBackdrop()
{
	YApplicationFigures::SetTextViewBackdrop( (QTextView&)textbrowser, YApplicationFigures::BACKGROUND_SOURCESVIEW );
}



//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void YLogFileViewFrame::SetBackdrop()
{
	YApplicationFigures::SetTextViewBackdrop( (QTextView&)textbrowser, YApplicationFigures::BACKGROUND_LOGFILEVIEW );
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int YLogFileViewFrame::InitInstance()
{
	//connect( & ((YEnvironment*)GetObject())->GetEnvironmentLogFileSet(), SIGNAL( RemoveLogFile() ), this, SLOT( CloseFrame() ) );
//#if QT_VERSION>=300
//	connect( (YEnvironment*)GetObject(), SIGNAL( EnvironmentExecuted() ), this, SLOT( reload() ) );
//#endif

  return YFileViewFrame::InitInstance();
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
YFilePath* YLogFileViewFrame::GetFilePath() const
{
	return &((YEnvironment*)GetObject())->GetLogFilePath();
}
