//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// YASA sources view
//
// Project: Yasa 2
// Author : Jan Blumenthal
// Start  : 2002/02/28
// $Header: /sources/yasa/yasagui/sourcesview.h,v 1.4 2003/01/24 15:47:42 bj Exp $
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (See the included file COPYING);
// if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef YASAGUI_SOURCESVIEW_INCLUDE
#define	YASAGUI_SOURCESVIEW_INCLUDE


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#include <qtextbrowser.h>
#include "yasagui/yasagui.h"
#include "config.h"
#include "mainwindow.h"
#include "sources.h"


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//! This frame is showing a source files
//! The reload slot of QT_Version V3 is used if possible.
class YFileViewFrame : public YObjectFrame
{	Q_OBJECT
protected:
	QTextBrowser		textbrowser;
public:					YFileViewFrame(QWidget *parent, YFrameArgs &args) :
						YObjectFrame(args),
						textbrowser(parent)
						{}
	virtual int			InitInstance();
	virtual QWidget*	GetMainWidget()								{ return &textbrowser;	}
	virtual void		SetBackdrop()=0;
	virtual YFilePath*	GetFilePath() const=0;
};

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//! This frame is showing a source files
//! YFrameArgs::object is a type of YFilePath
class YSourceViewFrame : public YFileViewFrame
{	public:				YSourceViewFrame(QWidget *parent, YFrameArgs &args) :
						YFileViewFrame(parent, args)	{}
	static YFrame*		CreateSourceViewFrame(QWidget *parent, YFrameArgs &args)
						{	return new YSourceViewFrame( parent, args);						}
	virtual void		SetBackdrop();
	virtual YFilePath*	GetFilePath() const				{	return (YFilePath*)GetObject();	}
};



//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//! This frame is showing a logfile files, YObject is a type of YEnvironment
class YLogFileViewFrame : public YFileViewFrame
{	public:				YLogFileViewFrame(QWidget *parent, YFrameArgs &args) :
						YFileViewFrame(parent, args)	{}
	static YFrame*		CreateLogFileViewFrame(QWidget *parent, YFrameArgs &args)
						{	return new YLogFileViewFrame( parent, args);						}
	virtual int			InitInstance();
	virtual void		SetBackdrop();
	virtual YFilePath*	GetFilePath() const;
};








//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif																			// ifndef YASAGUI_SOURCESVIEW_INCLUDE
