//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// YASA Statistics code
//
// Project: Yasa 2
// Author : Jan Blumenthal
// Start  : 2002/02/28
// $Header: /sources/yasa/yasagui/statistics.cpp,v 1.4 2003/01/30 09:29:55 bj Exp $
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (See the included file COPYING);
// if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#include "statistics.h"
#include "widgets.h"


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//! This function is called during InitInstance() and during YResultFrame::UpdateResults() after inserting YStatistics
int YStatistics::InitInstance(YStatisticHandler *handler, QWidget *parent)
{
	if ( handler && parent )
	{
		vbox=new QVBox(parent);
		if ( ! vbox )
			return YASAE_OUT_OF_MEMORY;
		label=new QLabel( GetTableTitle(), vbox);
		if ( !label )
			return YASAE_OUT_OF_MEMORY;
		table=new YStatisticTable( GetMaxProperties(), GetMaxEntries(), vbox, handler);
		if ( ! table )
			return YASAE_OUT_OF_MEMORY;
		FillTable();
		return 0;
	}
	return YASAE_ERROR_IN_ARGUMENTS;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void YStatistics::FillTable()
{
	YLogFileStatistics	*columnstatistics;
	unsigned int i,j;

	// fill table
	table->SetHorizontalNames( GetEntryNames() );
	table->SetVerticalNames( GetPropertyNames() );
	for ( i=0; i<GetMaxEntries() ; i++ )
	{
		columnstatistics=GetEntryLogFileStatistics(i);
		for ( j=0; j<GetMaxProperties() ; j++)
		{
			if ( columnstatistics )
				table->setItem( j, i, new YStatisticLogFileTableItem(table, columnstatistics->GetStatisticProperty(j) ) );
			else
				table->setItem( j, i, new YStatisticTableItem(table) );
		}
	}
	table->EnlargeTable();
}
