//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// YASA statistic windows declarations
//
// Project: Yasa 2
// Author : Jan Blumenthal
// Start  : 2002/03/18
// $Header: /sources/yasa/yasagui/statisticwindows.h,v 1.4 2003/01/24 15:47:43 bj Exp $
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (See the included file COPYING);
// if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// This file contains all information about statistic frames
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef YASAGUI_STATISTIC_WINDOWS_INCLUDE
#define	YASAGUI_STATISTIC_WINDOWS_INCLUDE


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#include <qsplitter.h>
#include "frame.h"
#include "environment.h"
#include "project.h"
#include "resultwindows.h"



//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//! This is a base class providing functionality to show different types of timings diagrams in a splitter window
class YStatisticEnvironmentResultFrame : public YEnvironmentResultFrame
{	Q_OBJECT
public:							YStatisticEnvironmentResultFrame(QWidget *parent, YFrameArgs &args) :
								YEnvironmentResultFrame(parent, args)
								{ }
protected:
	//! A timing handler can handle the different types of diagrams. Mostly used are "DiagramNameDiagrams"
	//! This is a splitter window. On the left side you can see the names of the timings and on the right
	//! side there is the diming diagram.
	virtual YResultHandler*		CreateResultHandler(QSplitter *parent) const;
	virtual int					InsertResults(YResultHandler *timinghandler) const;
};



//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//! This frame is showing the timing results of the simulation of the current project
//! YObjectFrame::GetObject() is a type of YProject*
class YStatisticProjectResultFrame : public YProjectResultFrame
{	Q_OBJECT
public:							YStatisticProjectResultFrame(QWidget *parent, YFrameArgs &args) :
								YProjectResultFrame(parent, args)
								{ }
protected:
	//! A statistic handler can handle the different types of statistics. Mostly used are "Tables"
	//! This is a splitter window. On the left side you can see the names of the timings and on the right
	//! side there is the diming diagram.
	virtual YResultHandler*		CreateResultHandler(QSplitter *parent) const;
	virtual int					InsertResults(YResultHandler *timinghandler) const;
};




//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif																			// ifndef YASAGUI_STATISTIC_WINDOWS_INCLUDE
