//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// YASA work space manager
//
// Project: Yasa 2
// Author : Jan Blumenthal
// Start  : 2002/02/28
// $Header: /sources/yasa/yasagui/workspacemanager.h,v 1.5 2003/01/24 15:47:44 bj Exp $
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (See the included file COPYING);
// if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef YASAGUI_WORKSPACEMANAGER_INCLUDE
#define	YASAGUI_WORKSPACEMANAGER_INCLUDE

#include <yasagui/yasagui.h>
#include <qobject.h>
#include <qlist.h>
#include "object.h"
#include "filedialog.h"


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
class YWorkSpace;
class YActionHandler;
class YApplication;

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//! Alive from start to end of application
class YWorkSpaceManager : public YObject
{
	Q_OBJECT
	YApplication			&application;
	YWorkSpace				*workspace;
	YActionHandler			*actionhandler;
	YFileDialog				filedialog;							//! filedialog is used to choose work space

	int						CreateNewWorkSpace();
public:						YWorkSpaceManager(YApplication &app);
							~YWorkSpaceManager()
							{
								CloseWorkSpace();
							}
	int						InitInstance(YActionHandler *ah)
							{
								actionhandler=ah;
								return 0;
							}
	YWorkSpace*				GetWorkSpace();
	virtual int				SetConfig(YInputParser &parser);
	virtual int				GetConfig(YOutputParser &parser);
	int						ReadWorkSpace(const QString &filename);
	int						WriteWorkSpace(const QString &newfilename);
	YApplication&			GetApplication() const							{	return application;	}
public slots:
	int						NewWorkSpace();
	void					OpenWorkSpace();
	void					CloseWorkSpace();
	void					SaveWorkSpace();
	void					SaveWorkSpaceAs();
signals:
	void					WorkSpaceDestroyed(YWorkSpace *);	//! Workspace will be destroyed after emitting signal
	void					NewWorkSpaceCreated(YWorkSpace *);	//! A new workspace was created
};


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif															// ifndef YASAGUI_WORKSPACEMANAGER_INCLUDE
